#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 180, 90/5, 75/5);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(65);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{

		let face = GetCurrentScriptDirectory~"face/Shou_";
		ObjCutin_SetSpellcardM4("Juicy Card \"What if it Could Rain Fruit Juice?\"", 3500000, "YABUSAME", face~"02.png", 212, 212, 144);
		// ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
		PlaySoundO1(spell_0);
		yield;
		ObjEnemyBossScene_StartSpell(objScene);
	
		Hold(90);
		Hold(90);
		let dir = rand(0,360);
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			ascent(i in 0..500){
				PlaySoundO2(e_shot_00, 65);
				if(i%2 == 0) {let shot1 = CreateObjShotA1(EnemyX+rand(-40,40),EnemyY+rand(-40,40),0,dir,rand(216,218),10);
				ObjMove_AddPatternA1(shot1,120,4,dir);}
				
				let shot2 = CreateObjShotA1(EnemyX+rand(-20,20),EnemyY+rand(-20,20),0,-dir,rand(45,48),10);
				ObjMove_AddPatternA1(shot2,120,2,-dir);
				dir+=5;
				if(i%100 == 0) {ObjMove_SetDestAtWeight(Enemy,rand(40,GetStgFrameWidth-40),GetStgFrameHeight/3-rand(10,60), 13, 5);}
				if(!Hold(1)){break;}
			}
		}
	}
	
}