#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 70, 75, 80);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(35);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
	
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 9, 6);
	
		Hold(90);
		while(ObjMove_GetSpeed(Enemy) > 0.5){yield;}

		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			let r = rand(0,360);
			let way = 1;
			ascent(i in 0..2){
				thingamabob(EnemyX+(160*way),EnemyY,way,r);
				way*=-1;
			}
			if(!Hold(420)){break;}
		}
	}

	task thingamabob(x,y,way,start){
		let dir = start;
		ascent(i in 0..120){
			ascent(j in 0..9){
				if(i%1 == 0) {let shot = CreateObjShotA1(x,y,6,dir,169,10);
				ObjRender_SetBlendType(shot,BLEND_ADD_ARGB);}
				dir+=360/9*way;
			}
			if(way == 1) {PlaySoundO2(e_shot_00,65);}
			if(!Hold(1)){break;}
			dir+=0.3*way;
		}
		ascent(i in 0..80){
			ascent(j in 0..9){
				if(i%3 == 0) {let shot = CreateObjShotA1(x,y,6-(i*0.075),dir,169,10);
				ObjRender_SetBlendType(shot,BLEND_ADD_ARGB);}
				dir-=360/9*way;
			}
			if(way == 1) {PlaySoundO2(e_shot_00,65);}
			if(!Hold(1)){break;}
			dir-=0.3*way;
		}
	}	
}