#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../../ds_system/S_System.txt"]

#include"./../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(55-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	SetInvincibility(Enemy, 180, 85/5, 60/5);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(55);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
		task PerformActions{
		let face = GetCurrentScriptDirectory~"face/Aoji_";
		ObjCutin_SetSpellcardM4("Faux Whirlpool \"Rince Cycle\"", 3500000, "YABUSAME", face~"02.png", 128, 164, 255);
		// ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
		PlaySoundO1(spell_0);
		yield;
		ObjEnemyBossScene_StartSpell(objScene);

		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 9, 6);
	
		Hold(90);
		Hold(90);
		antisafespot;
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			fluxring;
			if(!Hold(200)){break;}
		}
	}
}	


task antisafespot{
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		CreateObjShotA2(EnemyX,EnemyY,7,GetAngleToPlayer(Enemy),-0.2,1.7,260,10);
		PlaySoundO2(e_shot_01,70);
		if(!Hold(100)){break;}
	}
}

task fluxring {
	let flux = 90;
	let dir = rand(0,360);
	let dir2 = 0;
	let count = 0;
	ascent(i in 0..20){
		dir2+=360/10;
		flux = 10*sin(dir2);
		count+=1;
		loop(6){
			dir+=360/6;
			let bullet = CreateObjShotA1(EnemyX+30*cos(dir),EnemyY+30*sin(dir),2,dir-flux,50,20);
			ObjMove_SetAngularVelocity(bullet,flux*0.06);
			
			bullet = CreateObjShotA1(EnemyX+30*cos(dir),EnemyY+30*sin(dir),2.3,dir+flux,50,20);
			ObjMove_SetAngularVelocity(bullet,flux*0.06);
		}
		PlaySoundO2(e_shot_00,55);
		if(!Hold(10)){break;}
	}
}
